/* ***********************************************************
 * This file was automatically generated on 2018-11-28.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.20                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Generates configurable DC voltage between 0V and 5V
	/// </summary>
	public class BrickletAnalogOut : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 220;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Analog Out Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_VOLTAGE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_VOLTAGE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_MODE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_MODE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte MODE_ANALOG_VALUE = 0;

		/// <summary>
		/// </summary>
		public const byte MODE_1K_TO_GROUND = 1;

		/// <summary>
		/// </summary>
		public const byte MODE_100K_TO_GROUND = 2;

		/// <summary>
		/// </summary>
		public const byte MODE_500K_TO_GROUND = 3;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletAnalogOut(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;



			responseExpected[FUNCTION_SET_VOLTAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MODE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MODE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
		///  Calling this function will set the mode to 0 (see <see cref="Tinkerforge.BrickletAnalogOut.SetMode"/>).
		///  
		///  The default value is 0 (with mode 1).
		/// </summary>
		public void SetVoltage(int voltage)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_VOLTAGE);
			LEConverter.To((short)voltage, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the voltage as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		/// </summary>
		public int GetVoltage()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_VOLTAGE);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the mode of the analog value. Possible modes:
		///  
		///  * 0: Normal Mode (Analog value as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/> is applied)
		///  * 1: 1k Ohm resistor to ground
		///  * 2: 100k Ohm resistor to ground
		///  * 3: 500k Ohm resistor to ground
		///  
		///  Setting the mode to 0 will result in an output voltage of 0. You can jump
		///  to a higher output voltage directly by calling <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		///  
		///  The default mode is 1.
		/// </summary>
		public void SetMode(byte mode)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_SET_MODE);
			LEConverter.To((byte)mode, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the mode as set by <see cref="Tinkerforge.BrickletAnalogOut.SetMode"/>.
		/// </summary>
		public byte GetMode()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MODE);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}
	}
}
